// *************************************************
// *            BSCButton Control v1.00            *
// *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
// * Author : Simon Daykin                         *
// * e-mail : Simon@Byte-Sized.com                 *
// * Date   : 2nd May 1997                         *
// * Copyright 1996-1997 Byte-Sized Computing      *
// *                                               *
// * You are requested to achnowledge the original *
// * author of this source code in any code you    *
// * derrive based on this source code.            *
// *                                               *
// * IMPORTANT - Read the file licence.txt it      *
// * contains information regarding your usage of  *
// * this source code.                             *
// *************************************************
import java.awt.*;

public class BSCButton extends Canvas
{
	private Image img, D_img,U_img;
	private String Ret;
	private int Width, Height;
	private boolean Down = false;
	private boolean Initialized = false;
	private boolean MouseButDown = false;
	private Color C = Color.lightGray;

	public BSCButton(Image P_img, String P_Ret)
	{
		img = P_img;
		Ret = P_Ret;
		MediaTracker img_tracker = new MediaTracker(this);
        img_tracker.addImage(img,0);
        try {
			img_tracker.waitForID(0);
		}
		catch (InterruptedException e) {// exception handling
		}
		Width = img.getWidth(this)+(6);
		Height = img.getHeight(this)+(6);
	}

	public Dimension preferredSize()	{return new Dimension(Width, Height);}

	public Dimension minimumSize()		{return new Dimension(Width, Height);}

    public void update(Graphics g)		{paint(g);}

	public void paint(Graphics g)
	{	
		Graphics D_buf, U_buf; 
		if (!Initialized){
			D_img = createImage(Width, Height);
			U_img = createImage(Width, Height);
			D_buf = D_img.getGraphics();
			U_buf = U_img.getGraphics();
			//create the two button images
			D_buf.setColor(Color.black);
			D_buf.fillRect(0, 0, Width , Height);
			D_buf.setColor(C);
			D_buf.fill3DRect(1, 1, Width-1 , Height-1 , false);
			D_buf.fillRect(2, 2, Width-3 , Height-3);
			D_buf.drawImage(img, 3, 3, this);
			D_buf.dispose();

			U_buf.setColor(Color.black);
			U_buf.fillRect(0, 0, Width , Height);
			U_buf.setColor(C);
			U_buf.fill3DRect(0, 0, Width-1 , Height-1 , true);
			U_buf.drawImage(img, 2, 2, this);
			U_buf.dispose();

			Initialized = true;
		}
		
		if (Down) {
			g.drawImage(D_img, 0, 0, this);
		}
		else {
			g.drawImage(U_img, 0, 0, this);
		}

	}

	public void setColor(Color c) { 
		C = c;
		Initialized = false;
		repaint();
	}

	public boolean mouseDown(Event evt, int x, int y) {
		Down = true;
		MouseButDown = true;
		repaint();
		return true;
	}

	public boolean mouseUp(Event evt, int x, int y) {
		Down = false;
		MouseButDown = false;
		repaint();
		if (inside(x,y)) {postEvent(new Event(this, Event.ACTION_EVENT, Ret));}
		return true;
	}			   

	public boolean action(Event e, Object o) {
		return false;
	}


	public boolean mouseEnter(Event  evt, int  x, int  y) {
		if (MouseButDown) {Down = true;}
		repaint();
		return true;
	}

	public boolean mouseExit(Event  evt, int  x, int  y) {
		if (MouseButDown) {Down = false;}
		repaint();
		return true;
	}

}//end of class