// *************************************************
// *            BSCButtonBar Applet v1.00          *
// *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
// * Author : Simon Daykin                         *
// * e-mail : Simon@Byte-Sized.com                 *
// * Date   : 2nd May 1997                         *
// * Copyright 1996-1997 Byte-Sized Computing      *
// *                                               *
// * You are requested to achnowledge the original *
// * author of this source code in any code you    *
// * derrive based on this source code.            *
// *                                               *
// * IMPORTANT - Read the file licence.txt it      *
// * contains information regarding your usage of  *
// * this source code.                             *
// *************************************************
import java.applet.*;
import java.awt.*;
import java.net.*;
import BSCButton;

public class BSCButtonBar extends Applet
{

	private String P_Target = "_top";
	private Color P_BGColour = Color.lightGray;

	private int NumButs;

	public String[][] getParameterInfo()
	{
		String[][] info =
		{
			{ "Target", "String", "Target Frame" },
			{ "Iconx", "String", "Icon Filename relative to BSBButton.Class file" },
			{ "Jumpx", "String", "URL to jump to relative to the document URL" },
			{ "Alignment", "Integer", "0=Left 1=Center 2=Right" },
			{ "Spacing", "Integer", "Distance between buttons" },
		};
		return info;		
	}


	public String getAppletInfo()
	{
		return "Name: BSCButtonBar\r\n" +
		       "Author: Simon Daykin\r\n";
	}


	public void init()
	{

		String param;
		String P_Jump;
		Image P_Icon;
		Color P_ButColour = Color.lightGray;
		int P_Align = 0;
		int P_Spacing = 5;

		param = getParameter("Target");
		if (param != null)
			P_Target = param;
		
		param = getParameter("Alignment");
		if (param != null)
			P_Align = Integer.parseInt(param);

		param = getParameter("Spacing");
		if (param != null)
			P_Spacing = Integer.parseInt(param);

		setLayout(new FlowLayout(P_Align, P_Spacing, P_Spacing));

		param = getParameter("BGColour");
		if (param != null)
			P_BGColour = new Color(Integer.parseInt(param, 16));

		param = getParameter("ButColour");
		if (param != null)
			P_ButColour = new Color(Integer.parseInt(param, 16));

		NumButs=0;
		boolean MoreButs=true;

		BSCButton NewBut;
		while (MoreButs) {
			if (getParameter("Icon" + Integer.toString(NumButs+1)) != null){
				NumButs++;
				param = getParameter("Icon" + Integer.toString(NumButs));
				P_Icon = getImage(getDocumentBase(), param);
				
				param = getParameter("Jump" + Integer.toString(NumButs));
				P_Jump = param;

				NewBut = new BSCButton(P_Icon, P_Jump);
				add(NewBut);
				NewBut.setColor(P_ButColour);
			}
			else {
				MoreButs = false;
			}
		}
	}

	public void destroy()
	{
	}

	public void paint(Graphics g)
	{
		g.setColor(P_BGColour);
		g.fillRect(0, 0, size().width, size().height);
	}

	public void start()
	{
	}
	
	public void stop()
	{
	}

	public boolean action(Event e, Object o) 
	{
		try{
			getAppletContext().showDocument(new URL(getDocumentBase(),o.toString()), P_Target);
			}
		catch (Exception ex){} 
	return true;
	}

	

	public boolean mouseDown(Event evt, int x, int y)
	{
		return true;
	}

	public boolean mouseUp(Event evt, int x, int y)
	{
		return true;
	}

}
